#ifndef NOTEPAD_EDITOR_H
#define NOTEPAD_EDITOR_H

#include "tab_docs.h"
#include "savedialog.h"
#include <QMainWindow>
#include <QtWidgets>

class notepad_editor_class : public QMainWindow
{
    Q_OBJECT
private:
    QTabWidget* _tabWid;
    unsigned int _newTabsCount;
    QSignalMapper* _sigMapper;
    QDockWidget* _dockFileSysWid;
    QDockWidget* _dockTabsWid;
    QTreeView* _treeFileSysView;
    QListView* _tableTabsView;
    QFileSystemModel* _sysModel;
    QStringListModel* _strListModel;
    QStringList _openedTabsNames;
    QStringList _openedTabsDirectories;
    QStringList _codeExtensions;
    QString _newTabName;
    int _amountOfChanged;

protected:
    void closeEvent(QCloseEvent *event);


private:
    doc_tab_class* createNewDocument();
    void getExtensionsFromIni();

public:
    notepad_editor_class(QWidget *parent = nullptr);
    ~notepad_editor_class();

public slots:
    void sltSetActiveTab(QWidget*);
    void sltSetActiveTab(const QModelIndex&);
    void sltFileBrowser() const;
    void sltOnClose();
    void sltSaveAs();
    void sltSaveAll();
    void sltClose();
    void sltCloseIdx(int);
    bool sltCloseAll();
    void sltChangeTabTitle(const QString&, const QString&);
    void sltCopy() const;
    void sltCut() const;
    void sltPaste() const;
    void sltDelete() const;
    void sltSelectAll() const;
    void sltFileChanged(const QString&);
    void sltNewDocument();
    void sltOpen();
    void sltOpenIdx(const QModelIndex&);
    void sltSave();
    void sltTabs() const;


};
#endif // NOTEPAD_EDITOR_H